diff --git a/_ide_helper.php b/_ide_helper.php
index b307038..7f7a796 100644
--- a/_ide_helper.php
+++ b/_ide_helper.php
@@ -4315,343 +4489,343 @@ namespace {
         }
         
         /**
-         * Add a where between statement to the query.
+         * Add a "where in" clause to the query.
          *
          * @param string $column
-         * @param array $values
+         * @param mixed $values
          * @param string $boolean
          * @param bool $not
          * @return $this 
          * @static 
          */
-        public static function whereBetween($column, $values, $boolean = 'and', $not = false){
-            return \Illuminate\Database\Query\Builder::whereBetween($column, $values, $boolean, $not);
+        public static function whereIn($column, $values, $boolean = 'and', $not = false){
+            return \Illuminate\Database\Query\Builder::whereIn($column, $values, $boolean, $not);
         }
         
         /**
-         * Add an or where between statement to the query.
+         * Add an "or where in" clause to the query.
          *
          * @param string $column
-         * @param array $values
+         * @param mixed $values
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereBetween($column, $values){
-            return \Illuminate\Database\Query\Builder::orWhereBetween($column, $values);
+        public static function orWhereIn($column, $values){
+            return \Illuminate\Database\Query\Builder::orWhereIn($column, $values);
         }
         
         /**
-         * Add a where not between statement to the query.
+         * Add a "where not in" clause to the query.
          *
          * @param string $column
-         * @param array $values
+         * @param mixed $values
          * @param string $boolean
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function whereNotBetween($column, $values, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereNotBetween($column, $values, $boolean);
+        public static function whereNotIn($column, $values, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereNotIn($column, $values, $boolean);
         }
         
         /**
-         * Add an or where not between statement to the query.
+         * Add an "or where not in" clause to the query.
          *
          * @param string $column
-         * @param array $values
+         * @param mixed $values
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereNotBetween($column, $values){
-            return \Illuminate\Database\Query\Builder::orWhereNotBetween($column, $values);
+        public static function orWhereNotIn($column, $values){
+            return \Illuminate\Database\Query\Builder::orWhereNotIn($column, $values);
         }
         
         /**
-         * Add a nested where statement to the query.
+         * Add a "where null" clause to the query.
          *
-         * @param \Closure $callback
+         * @param string $column
          * @param string $boolean
-         * @return \Illuminate\Database\Query\Builder|static 
+         * @param bool $not
+         * @return $this 
          * @static 
          */
-        public static function whereNested($callback, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereNested($callback, $boolean);
+        public static function whereNull($column, $boolean = 'and', $not = false){
+            return \Illuminate\Database\Query\Builder::whereNull($column, $boolean, $not);
         }
         
         /**
-         * Create a new query instance for nested where condition.
+         * Add an "or where null" clause to the query.
          *
-         * @return \Illuminate\Database\Query\Builder 
+         * @param string $column
+         * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function forNestedWhere(){
-            return \Illuminate\Database\Query\Builder::forNestedWhere();
+        public static function orWhereNull($column){
+            return \Illuminate\Database\Query\Builder::orWhereNull($column);
         }
         
         /**
-         * Add another query builder as a nested where to the query builder.
+         * Add a "where not null" clause to the query.
          *
-         * @param \Illuminate\Database\Query\Builder|static $query
+         * @param string $column
          * @param string $boolean
-         * @return $this 
+         * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function addNestedWhereQuery($query, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::addNestedWhereQuery($query, $boolean);
+        public static function whereNotNull($column, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereNotNull($column, $boolean);
         }
         
         /**
-         * Add an exists clause to the query.
+         * Add a where between statement to the query.
          *
-         * @param \Closure $callback
+         * @param string $column
+         * @param array $values
          * @param string $boolean
          * @param bool $not
          * @return $this 
          * @static 
          */
-        public static function whereExists($callback, $boolean = 'and', $not = false){
-            return \Illuminate\Database\Query\Builder::whereExists($callback, $boolean, $not);
+        public static function whereBetween($column, $values, $boolean = 'and', $not = false){
+            return \Illuminate\Database\Query\Builder::whereBetween($column, $values, $boolean, $not);
         }
         
         /**
-         * Add an or exists clause to the query.
+         * Add an or where between statement to the query.
          *
-         * @param \Closure $callback
-         * @param bool $not
+         * @param string $column
+         * @param array $values
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereExists($callback, $not = false){
-            return \Illuminate\Database\Query\Builder::orWhereExists($callback, $not);
+        public static function orWhereBetween($column, $values){
+            return \Illuminate\Database\Query\Builder::orWhereBetween($column, $values);
         }
         
         /**
-         * Add a where not exists clause to the query.
+         * Add a where not between statement to the query.
          *
-         * @param \Closure $callback
+         * @param string $column
+         * @param array $values
          * @param string $boolean
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function whereNotExists($callback, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereNotExists($callback, $boolean);
+        public static function whereNotBetween($column, $values, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereNotBetween($column, $values, $boolean);
         }
         
         /**
-         * Add a where not exists clause to the query.
+         * Add an or where not between statement to the query.
          *
-         * @param \Closure $callback
+         * @param string $column
+         * @param array $values
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereNotExists($callback){
-            return \Illuminate\Database\Query\Builder::orWhereNotExists($callback);
+        public static function orWhereNotBetween($column, $values){
+            return \Illuminate\Database\Query\Builder::orWhereNotBetween($column, $values);
         }
         
         /**
-         * Add an exists clause to the query.
+         * Add an "or where not null" clause to the query.
          *
-         * @param \Illuminate\Database\Query\Builder $query
-         * @param string $boolean
-         * @param bool $not
-         * @return $this 
+         * @param string $column
+         * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function addWhereExistsQuery($query, $boolean = 'and', $not = false){
-            return \Illuminate\Database\Query\Builder::addWhereExistsQuery($query, $boolean, $not);
+        public static function orWhereNotNull($column){
+            return \Illuminate\Database\Query\Builder::orWhereNotNull($column);
         }
         
         /**
-         * Add a "where in" clause to the query.
+         * Add a "where date" statement to the query.
          *
          * @param string $column
-         * @param mixed $values
+         * @param string $operator
+         * @param mixed $value
          * @param string $boolean
-         * @param bool $not
-         * @return $this 
+         * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function whereIn($column, $values, $boolean = 'and', $not = false){
-            return \Illuminate\Database\Query\Builder::whereIn($column, $values, $boolean, $not);
+        public static function whereDate($column, $operator, $value = null, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereDate($column, $operator, $value, $boolean);
         }
         
         /**
-         * Add an "or where in" clause to the query.
+         * Add an "or where date" statement to the query.
          *
          * @param string $column
-         * @param mixed $values
+         * @param string $operator
+         * @param string $value
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereIn($column, $values){
-            return \Illuminate\Database\Query\Builder::orWhereIn($column, $values);
+        public static function orWhereDate($column, $operator, $value){
+            return \Illuminate\Database\Query\Builder::orWhereDate($column, $operator, $value);
         }
         
         /**
-         * Add a "where not in" clause to the query.
+         * Add a "where time" statement to the query.
          *
          * @param string $column
-         * @param mixed $values
+         * @param string $operator
+         * @param int $value
          * @param string $boolean
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function whereNotIn($column, $values, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereNotIn($column, $values, $boolean);
+        public static function whereTime($column, $operator, $value, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereTime($column, $operator, $value, $boolean);
         }
         
         /**
-         * Add an "or where not in" clause to the query.
+         * Add an "or where time" statement to the query.
          *
          * @param string $column
-         * @param mixed $values
+         * @param string $operator
+         * @param int $value
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereNotIn($column, $values){
-            return \Illuminate\Database\Query\Builder::orWhereNotIn($column, $values);
+        public static function orWhereTime($column, $operator, $value){
+            return \Illuminate\Database\Query\Builder::orWhereTime($column, $operator, $value);
         }
         
         /**
-         * Add a "where null" clause to the query.
+         * Add a "where day" statement to the query.
          *
          * @param string $column
+         * @param string $operator
+         * @param mixed $value
          * @param string $boolean
-         * @param bool $not
-         * @return $this 
+         * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function whereNull($column, $boolean = 'and', $not = false){
-            return \Illuminate\Database\Query\Builder::whereNull($column, $boolean, $not);
+        public static function whereDay($column, $operator, $value = null, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereDay($column, $operator, $value, $boolean);
         }
         
         /**
-         * Add an "or where null" clause to the query.
+         * Add a "where month" statement to the query.
          *
          * @param string $column
+         * @param string $operator
+         * @param mixed $value
+         * @param string $boolean
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereNull($column){
-            return \Illuminate\Database\Query\Builder::orWhereNull($column);
+        public static function whereMonth($column, $operator, $value = null, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereMonth($column, $operator, $value, $boolean);
         }
         
         /**
-         * Add a "where not null" clause to the query.
+         * Add a "where year" statement to the query.
          *
          * @param string $column
+         * @param string $operator
+         * @param mixed $value
          * @param string $boolean
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function whereNotNull($column, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereNotNull($column, $boolean);
+        public static function whereYear($column, $operator, $value = null, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereYear($column, $operator, $value, $boolean);
         }
         
         /**
-         * Add an "or where not null" clause to the query.
+         * Add a nested where statement to the query.
          *
-         * @param string $column
+         * @param \Closure $callback
+         * @param string $boolean
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereNotNull($column){
-            return \Illuminate\Database\Query\Builder::orWhereNotNull($column);
+        public static function whereNested($callback, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereNested($callback, $boolean);
         }
         
         /**
-         * Add a "where date" statement to the query.
+         * Create a new query instance for nested where condition.
          *
-         * @param string $column
-         * @param string $operator
-         * @param mixed $value
-         * @param string $boolean
-         * @return \Illuminate\Database\Query\Builder|static 
+         * @return \Illuminate\Database\Query\Builder 
          * @static 
          */
-        public static function whereDate($column, $operator, $value = null, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereDate($column, $operator, $value, $boolean);
+        public static function forNestedWhere(){
+            return \Illuminate\Database\Query\Builder::forNestedWhere();
         }
         
         /**
-         * Add an "or where date" statement to the query.
+         * Add another query builder as a nested where to the query builder.
          *
-         * @param string $column
-         * @param string $operator
-         * @param string $value
-         * @return \Illuminate\Database\Query\Builder|static 
+         * @param \Illuminate\Database\Query\Builder|static $query
+         * @param string $boolean
+         * @return $this 
          * @static 
          */
-        public static function orWhereDate($column, $operator, $value){
-            return \Illuminate\Database\Query\Builder::orWhereDate($column, $operator, $value);
+        public static function addNestedWhereQuery($query, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::addNestedWhereQuery($query, $boolean);
         }
         
         /**
-         * Add a "where time" statement to the query.
+         * Add an exists clause to the query.
          *
-         * @param string $column
-         * @param string $operator
-         * @param int $value
+         * @param \Closure $callback
          * @param string $boolean
-         * @return \Illuminate\Database\Query\Builder|static 
+         * @param bool $not
+         * @return $this 
          * @static 
          */
-        public static function whereTime($column, $operator, $value, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereTime($column, $operator, $value, $boolean);
+        public static function whereExists($callback, $boolean = 'and', $not = false){
+            return \Illuminate\Database\Query\Builder::whereExists($callback, $boolean, $not);
         }
         
         /**
-         * Add an "or where time" statement to the query.
+         * Add an or exists clause to the query.
          *
-         * @param string $column
-         * @param string $operator
-         * @param int $value
+         * @param \Closure $callback
+         * @param bool $not
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function orWhereTime($column, $operator, $value){
-            return \Illuminate\Database\Query\Builder::orWhereTime($column, $operator, $value);
+        public static function orWhereExists($callback, $not = false){
+            return \Illuminate\Database\Query\Builder::orWhereExists($callback, $not);
         }
         
         /**
-         * Add a "where day" statement to the query.
+         * Add a where not exists clause to the query.
          *
-         * @param string $column
-         * @param string $operator
-         * @param mixed $value
+         * @param \Closure $callback
          * @param string $boolean
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function whereDay($column, $operator, $value = null, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereDay($column, $operator, $value, $boolean);
+        public static function whereNotExists($callback, $boolean = 'and'){
+            return \Illuminate\Database\Query\Builder::whereNotExists($callback, $boolean);
         }
         
         /**
-         * Add a "where month" statement to the query.
+         * Add a where not exists clause to the query.
          *
-         * @param string $column
-         * @param string $operator
-         * @param mixed $value
-         * @param string $boolean
+         * @param \Closure $callback
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function whereMonth($column, $operator, $value = null, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereMonth($column, $operator, $value, $boolean);
+        public static function orWhereNotExists($callback){
+            return \Illuminate\Database\Query\Builder::orWhereNotExists($callback);
         }
         
         /**
-         * Add a "where year" statement to the query.
+         * Add an exists clause to the query.
          *
-         * @param string $column
-         * @param string $operator
-         * @param mixed $value
+         * @param \Illuminate\Database\Query\Builder $query
          * @param string $boolean
-         * @return \Illuminate\Database\Query\Builder|static 
+         * @param bool $not
+         * @return $this 
          * @static 
          */
-        public static function whereYear($column, $operator, $value = null, $boolean = 'and'){
-            return \Illuminate\Database\Query\Builder::whereYear($column, $operator, $value, $boolean);
+        public static function addWhereExistsQuery($query, $boolean = 'and', $not = false){
+            return \Illuminate\Database\Query\Builder::addWhereExistsQuery($query, $boolean, $not);
         }
         
         /**
@@ -4742,6 +4916,17 @@ namespace {
         }
         
         /**
+         * Add a descending "order by" clause to the query.
+         *
+         * @param string $column
+         * @return $this 
+         * @static 
+         */
+        public static function orderByDesc($column){
+            return \Illuminate\Database\Query\Builder::orderByDesc($column);
+        }
+        
+        /**
          * Add an "order by" clause for a timestamp to the query.
          *
          * @param string $column
@@ -4787,17 +4972,6 @@ namespace {
         }
         
         /**
-         * Set the "offset" value of the query.
-         *
-         * @param int $value
-         * @return $this 
-         * @static 
-         */
-        public static function offset($value){
-            return \Illuminate\Database\Query\Builder::offset($value);
-        }
-        
-        /**
          * Alias to set the "offset" value of the query.
          *
          * @param int $value
@@ -4809,14 +4983,14 @@ namespace {
         }
         
         /**
-         * Set the "limit" value of the query.
+         * Set the "offset" value of the query.
          *
          * @param int $value
          * @return $this 
          * @static 
          */
-        public static function limit($value){
-            return \Illuminate\Database\Query\Builder::limit($value);
+        public static function offset($value){
+            return \Illuminate\Database\Query\Builder::offset($value);
         }
         
         /**
@@ -4831,6 +5005,17 @@ namespace {
         }
         
         /**
+         * Set the "limit" value of the query.
+         *
+         * @param int $value
+         * @return $this 
+         * @static 
+         */
+        public static function limit($value){
+            return \Illuminate\Database\Query\Builder::limit($value);
+        }
+        
+        /**
          * Set the limit and offset for a given page.
          *
          * @param int $page
@@ -4881,7 +5066,7 @@ namespace {
         /**
          * Lock the selected rows in the table.
          *
-         * @param bool $value
+         * @param string|bool $value
          * @return $this 
          * @static 
          */
@@ -5088,18 +5273,6 @@ namespace {
         }
         
         /**
-         * Merge an array of where clauses and bindings.
-         *
-         * @param array $wheres
-         * @param array $bindings
-         * @return void 
-         * @static 
-         */
-        public static function mergeWheres($wheres, $bindings){
-            \Illuminate\Database\Query\Builder::mergeWheres($wheres, $bindings);
-        }
-        
-        /**
          * Create a raw database expression.
          *
          * @param mixed $value
@@ -5198,22 +5371,56 @@ namespace {
         }
         
         /**
-         * Checks if macro is registered.
+         * Clone the query without the given properties.
          *
-         * @param string $name
-         * @return bool 
+         * @param array $except
+         * @return static 
          * @static 
          */
-        public static function hasMacro($name){
-            return \Illuminate\Database\Query\Builder::hasMacro($name);
+        public static function cloneWithout($except){
+            return \Illuminate\Database\Query\Builder::cloneWithout($except);
         }
         
         /**
-         * Dynamically handle calls to the class.
+         * Clone the query without the given bindings.
          *
-         * @param string $method
-         * @param array $parameters
-         * @return mixed 
+         * @param array $except
+         * @return static 
+         * @static 
+         */
+        public static function cloneWithoutBindings($except){
+            return \Illuminate\Database\Query\Builder::cloneWithoutBindings($except);
+        }
+        
+        /**
+         * Register a custom macro.
+         *
+         * @param string $name
+         * @param callable $macro
+         * @return void 
+         * @static 
+         */
+        public static function macro($name, $macro){
+            \Illuminate\Database\Query\Builder::macro($name, $macro);
+        }
+        
+        /**
+         * Checks if macro is registered.
+         *
+         * @param string $name
+         * @return bool 
+         * @static 
+         */
+        public static function hasMacro($name){
+            return \Illuminate\Database\Query\Builder::hasMacro($name);
+        }
+        
+        /**
+         * Dynamically handle calls to the class.
+         *
+         * @param string $method
+         * @param array $parameters
+         * @return mixed 
          * @throws \BadMethodCallException
          * @static 
          */
@@ -5231,12 +5438,11 @@ namespace {
          *
          * @param string|array $events
          * @param mixed $listener
-         * @param int $priority
          * @return void 
          * @static 
          */
-        public static function listen($events, $listener, $priority = 0){
-            \Illuminate\Events\Dispatcher::listen($events, $listener, $priority);
+        public static function listen($events, $listener){
+            \Illuminate\Events\Dispatcher::listen($events, $listener);
         }
         
         /**
@@ -5263,6 +5469,17 @@ namespace {
         }
         
         /**
+         * Flush a set of pushed events.
+         *
+         * @param string $event
+         * @return void 
+         * @static 
+         */
+        public static function flush($event){
+            \Illuminate\Events\Dispatcher::flush($event);
+        }
+        
+        /**
          * Register an event subscriber with the dispatcher.
          *
          * @param object|string $subscriber
@@ -5277,8 +5494,8 @@ namespace {
          * Fire an event until the first non-null response is returned.
          *
          * @param string|object $event
-         * @param array $payload
-         * @return mixed 
+         * @param mixed $payload
+         * @return array|null 
          * @static 
          */
         public static function until($event, $payload = array()){
@@ -5286,24 +5503,16 @@ namespace {
         }
         
         /**
-         * Flush a set of pushed events.
-         *
-         * @param string $event
-         * @return void 
-         * @static 
-         */
-        public static function flush($event){
-            \Illuminate\Events\Dispatcher::flush($event);
-        }
-        
-        /**
-         * Get the event that is currently firing.
+         * Fire an event and call the listeners.
          *
-         * @return string 
+         * @param string|object $event
+         * @param mixed $payload
+         * @param bool $halt
+         * @return array|null 
          * @static 
          */
-        public static function firing(){
-            return \Illuminate\Events\Dispatcher::firing();
+        public static function fire($event, $payload = array(), $halt = false){
+            return \Illuminate\Events\Dispatcher::fire($event, $payload, $halt);
         }
         
         /**
@@ -5315,8 +5524,8 @@ namespace {
          * @return array|null 
          * @static 
          */
-        public static function fire($event, $payload = array(), $halt = false){
-            return \Illuminate\Events\Dispatcher::fire($event, $payload, $halt);
+        public static function dispatch($event, $payload = array(), $halt = false){
+            return \Illuminate\Events\Dispatcher::dispatch($event, $payload, $halt);
         }
         
         /**
@@ -5333,23 +5542,25 @@ namespace {
         /**
          * Register an event listener with the dispatcher.
          *
-         * @param mixed $listener
-         * @return mixed 
+         * @param string|\Closure $listener
+         * @param bool $wildcard
+         * @return \Closure 
          * @static 
          */
-        public static function makeListener($listener){
-            return \Illuminate\Events\Dispatcher::makeListener($listener);
+        public static function makeListener($listener, $wildcard = false){
+            return \Illuminate\Events\Dispatcher::makeListener($listener, $wildcard);
         }
         
         /**
          * Create a class based listener using the IoC container.
          *
-         * @param mixed $listener
+         * @param string $listener
+         * @param bool $wildcard
          * @return \Closure 
          * @static 
          */
-        public static function createClassListener($listener){
-            return \Illuminate\Events\Dispatcher::createClassListener($listener);
+        public static function createClassListener($listener, $wildcard = false){
+            return \Illuminate\Events\Dispatcher::createClassListener($listener, $wildcard);
         }
         
         /**
@@ -5448,6 +5659,17 @@ namespace {
         }
         
         /**
+         * Get the MD5 hash of the file at the given path.
+         *
+         * @param string $path
+         * @return string 
+         * @static 
+         */
+        public static function hash($path){
+            return \Illuminate\Filesystem\Filesystem::hash($path);
+        }
+        
+        /**
          * Write the contents of a file.
          *
          * @param string $path
@@ -5485,6 +5707,18 @@ namespace {
         }
         
         /**
+         * Get or set UNIX mode of a file or directory.
+         *
+         * @param string $path
+         * @param int $mode
+         * @return mixed 
+         * @static 
+         */
+        public static function chmod($path, $mode = null){
+            return \Illuminate\Filesystem\Filesystem::chmod($path, $mode);
+        }
+        
+        /**
          * Delete the file at a given path.
          *
          * @param string|array $paths
@@ -5827,6 +6061,19 @@ namespace {
         }
         
         /**
+         * Define abilities for a resource.
+         *
+         * @param string $name
+         * @param string $class
+         * @param array $abilities
+         * @return $this 
+         * @static 
+         */
+        public static function resource($name, $class, $abilities = null){
+            return \Illuminate\Auth\Access\Gate::resource($name, $class, $abilities);
+        }
+        
+        /**
          * Define a policy class for a given class type.
          *
          * @param string $class
@@ -5914,7 +6161,6 @@ namespace {
          *
          * @param object|string $class
          * @return mixed 
-         * @throws \InvalidArgumentException
          * @static 
          */
         public static function getPolicyFor($class){
@@ -5943,6 +6189,16 @@ namespace {
             return \Illuminate\Auth\Access\Gate::forUser($user);
         }
         
+        /**
+         * Get all of the defined abilities.
+         *
+         * @return array 
+         * @static 
+         */
+        public static function abilities(){
+            return \Illuminate\Auth\Access\Gate::abilities();
+        }
+        
     }
 
 
